import { world, system } from "@minecraft/server";

const EntitiesDeny = [
    "minecraft:ender_crystal",
    "minecraft:ender_dragon",
    "minecraft:falling_block",
    "minecraft:player",

];

const EntityNames = {
    //--- Mobs Passivos: ---

    //1//
    "minecraft:allay": "§l§bAllay", // Azul claro

    //2//
    "minecraft:armadillo": "§l§6Armadillo", // Dourado

    //3//
    "minecraft:axolotl": "§l§dAxolotl", // Rosa

    //4//
    "minecraft:bat": "§l§8Bat", // Cinza escuro

    //5//
    "minecraft:camel": "§l§eCamel", // Amarelo claro

    //6//
    "minecraft:cat": "§l§7Cat", // Cinza

    //7//
    "minecraft:chicken": "§l§fChicken", // Branco

    //8//
    "minecraft:cod": "§l§9Cod", // Azul

    //9//
    "minecraft:cow": "§l§0Cow", // Preto

    //10//
    "minecraft:donkey": "§l§6Donkey", // Dourado

    //11//
    "minecraft:fox": "§l§cFox", // Vermelho

    //12//
    "minecraft:frog": "§l§2Frog", // Verde

    //13//
    "minecraft:glowsquid": "§l§bGlow Squid", // Azul claro

    //14//
    "minecraft:horse": "§l§aHorse", // Verde claro

    //15//
    "minecraft:mooshroom": "§l§4Mooshroom", // Vermelho escuro

    //16//
    "minecraft:mule": "§l§6Mule", // Dourado

    //17//
    "minecraft:ocelot": "§l§eOcelot", // Amarelo claro

    //18//
    "minecraft:panda": "§l§fPanda", // Branco

    //19//
    "minecraft:parrot": "§l§dParrot", // Rosa

    //20//
    "minecraft:pig": "§l§dPig", // Rosa

    //21//
    "minecraft:rabbit": "§l§fRabbit", // Branco

    //22//
    "minecraft:salmon": "§l§cSalmon", // Vermelho

    //23//
    "minecraft:sheep": "§l§fSheep", // Branco

    //24//
    "minecraft:sheeprainbow": "§l§fSheep (Rainbow)", // Branco

    //25//
    "minecraft:skeletonhorse": "§l§7Skeleton Horse", // Cinza

    //26//
    "minecraft:sniffer": "§l§2Sniffer", // Verde

    //27//
    "minecraft:snowgolem": "§l§fSnow Golem", // Branco

    //28//
    "minecraft:squid": "§l§1Squid", // Azul escuro

    //29//
    "minecraft:strider": "§l§5Strider", // Roxo

    //30//
    "minecraft:tadpole": "§l§2Tadpole", // Verde

    //31//
    "minecraft:tropicalfish": "§l§bTropical Fish", // Azul claro

    //32//
    "minecraft:turtle": "§l§2Turtle", // Verde

    //33//
    "minecraft:villager": "§l§6Villager", // Dourado

    //34//
    "minecraft:zombiehorse": "§l§2Zombie Horse", // Verde

    //--- Mobs Hostis: ---

    //35//
    "minecraft:blaze": "§l§6Blaze", // Dourado

    //36//
    "minecraft:bogged": "§l§2Bogged", // Verde

    //37//
    "minecraft:breeze": "§l§bBreeze", // Azul claro

    //38//
    "minecraft:creeper": "§l§2Creeper", // Verde

    //39//
    "minecraft:drowned": "§l§3Drowned", // Azul petróleo

    //40//
    "minecraft:elderguardian": "§l§1Elder Guardian", // Azul escuro

    //41//
    "minecraft:enderdragon": "§l§5Ender Dragon", // Roxo

    //42//
    "minecraft:endermite": "§l§5Endermite", // Roxo

    //43//
    "minecraft:evoker": "§l§7Evoker", // Cinza

    //44//
    "minecraft:ghast": "§l§fGhast", // Branco

    //45//
    "minecraft:guardian": "§l§1Guardian", // Azul escuro

    //46//
    "minecraft:hoglin": "§l§6Hoglin", // Dourado

    //47//
    "minecraft:husk": "§l§7Husk", // Cinza

    //48//
    "minecraft:magma_cube": "§l§4Magma Cube", // Vermelho escuro

    //49//
    "minecraft:phantom": "§l§3Phantom", // Azul petróleo

    //50//
    "minecraft:piglin": "§l§ePiglin", // Amarelo claro

    //51//
    "minecraft:piglin_brute": "§l§6Piglin Brute", // Dourado

    //52//
    "minecraft:pillager": "§l§7Pillager", // Cinza

    //53//
    "minecraft:ravager": "§l§8Ravager", // Cinza escuro

    //54//
    "minecraft:shulker": "§l§5Shulker", // Roxo

    //55//
    "minecraft:silverfish": "§l§7Silverfish", // Cinza

    //56//
    "minecraft:skeleton": "§l§7Skeleton", // Cinza

    //57//
    "minecraft:slime": "§l§2Slime", // Verde

    //58//
    "minecraft:stray": "§l§8Stray", // Cinza escuro

    //59//
    "minecraft:vex": "§l§7Vex", // Cinza

    //60//
    "minecraft:vindicator": "§l§7Vindicator", // Cinza

    //61//
    "minecraft:warden": "§l§0Warden", // Preto

    //62//
    "minecraft:witch": "§l§5Witch", // Roxo

    //63//
    "minecraft:wither_boss": "§l§0Wither Boss", // Preto

    //64//
    "minecraft:wither_skeleton": "§l§8Wither Skeleton", // Cinza escuro

    //65//
    "minecraft:zoglin": "§l§6Zoglin", // Dourado

    //66//
    "minecraft:zombie": "§l§2Zombie", // Verde

    //67//
    "minecraft:zombie_villager": "§l§2Zombie Villager", // Verde

    //--- Mobs Neutros: ---

    //68//
    "minecraft:bee": "§l§eBee", // Amarelo claro

    //69//
    "minecraft:cave_spider": "§l§2Cave Spider", // Verde

    //70//
    "minecraft:dolphin": "§l§7Dolphin", // Cinza

    //71//
    "minecraft:enderman": "§l§5Enderman", // Roxo

    //72//
    "minecraft:goat": "§l§fGoat", // Branco

    //73//
    "minecraft:iron_golem": "§l§7Iron Golem", // Cinza

    //74//
    "minecraft:llama": "§l§eLlama", // Amarelo claro

    //75//
    "minecraft:polar_bear": "§l§fPolar Bear", // Branco

    //76//
    "minecraft:pufferfish": "§l§ePufferfish", // Amarelo claro

    //77//
    "minecraft:spider": "§l§2Spider", // Verde

    //78//
    "minecraft:trader_llama": "§l§eTrader Llama", // Amarelo claro

    //79//
    "minecraft:wandering_trader": "§l§bWandering Trader", // Azul claro

    //80//
    "minecraft:wolf": "§l§7Wolf", // Cinza

    //81//
    "minecraft:zombie_pigman": "§l§2Zombie Pigman" // Verde
};


const EntityLores = {
    //§r-§r-§r- Passive Mobs: §r-§r-§r-

    //1//
    "minecraft:allay": [
        "§r- Small blue being, loves to dance to music."
    ], // Light Blue

    //2//
    "minecraft:armadillo": [
        "§r- Natural armor, master of protection."
    ], // Gold

    //3//
    "minecraft:axolotl": [
        "§r- Aquatic creature with regeneration."
    ], // Pink

    //4//
    "minecraft:bat": [
        "§r- Nocturnal creature, explores caves."
    ], // Dark Gray

    //5//
    "minecraft:camel": [
        "§r- Majestic for desert travels."
    ], // Light Yellow

    //6//
    "minecraft:cat": [
        "§r- Independent and great hunter."
    ], // Gray

    //7//
    "minecraft:chicken": [
        "§r- Source of eggs and food."
    ], // White

    //8//
    "minecraft:cod": [
        "§r- Common fish in rivers and oceans."
    ], // Blue

    //9//
    "minecraft:cow": [
        "§r- Source of milk and leather."
    ], // Black

    //10//
    "minecraft:donkey": [
        "§r- Carries heavy loads on travels."
    ], // Gold

    //11//
    "minecraft:fox": [
        "§r- Cunning and agile, seen at night."
    ], // Red

    //12//
    "minecraft:frog": [
        "§r- Likes swamps, leaping."
    ], // Green

    //13//
    "minecraft:glowsquid": [
        "§r- Lights up the ocean depths."
    ], // Light Blue

    //14//
    "minecraft:horse": [
        "§r- Noble, fast, and strong."
    ], // Light Green

    //15//
    "minecraft:mooshroom": [
        "§r- Cow covered in mushrooms."
    ], // Dark Red

    //16//
    "minecraft:mule": [
        "§r- Combines strength and stamina."
    ], // Gold

    //17//
    "minecraft:ocelot": [
        "§r- Prefers to avoid humans."
    ], // Light Yellow

    //18//
    "minecraft:panda": [
        "§r- Loves bamboo, rolls and plays."
    ], // White

    //19//
    "minecraft:parrot": [
        "§r- Colorful, mimics sounds."
    ], // Pink

    //20//
    "minecraft:pig": [
        "§r- Source of pork."
    ], // Pink

    //21//
    "minecraft:rabbit": [
        "§r- Small, agile, loves carrots."
    ], // White

    //22//
    "minecraft:salmon": [
        "§r- Tasty fish from rivers."
    ], // Red

    //23//
    "minecraft:sheep": [
        "§r- Provides wool for building."
    ], // White

    //24//
    "minecraft:sheeprainbow": [
        "§r- Rare sheep, changes color."
    ], // White

    //25//
    "minecraft:skeletonhorse": [
        "§r- Horse seen in storms."
    ], // Gray

    //26//
    "minecraft:sniffer": [
        "§r- Searches for ancient seeds."
    ], // Green

    //27//
    "minecraft:snowgolem": [
        "§r- Magical creation, throws snowballs."
    ], // White

    //28//
    "minecraft:squid": [
        "§r- Common ocean dweller."
    ], // Dark Blue

    //29//
    "minecraft:strider": [
        "§r- Loves swimming in lava."
    ], // Purple

    //30//
    "minecraft:tadpole": [
        "§r- Young form of a frog."
    ], // Green

    //31//
    "minecraft:tropicalfish": [
        "§r- Colorful fish from tropical biomes."
    ], // Light Blue

    //32//
    "minecraft:turtle": [
        "§r- Slow but graceful swimmer."
    ], // Green

    //33//
    "minecraft:villager": [
        "§r- Trader in villages."
    ], // Gold

    //34//
    "minecraft:zombiehorse": [
        "§r- Zombie horse from dark places."
    ], // Green

    //§r-§r-§r- Hostile Mobs: §r-§r-§r-

    //35//
    "minecraft:blaze": [
        "§r- Flaming creature from the Nether."
    ], // Gold

    //36//
    "minecraft:bogged": [
        "§r- Haunts swamps and wet areas."
    ], // Green

    //37//
    "minecraft:breeze": [
        "§r- Air elemental, quick and agile."
    ], // Light Blue

    //38//
    "minecraft:creeper": [
        "§r- Explodes in proximity."
    ], // Green

    //39//
    "minecraft:drowned": [
        "§r- Aquatic zombie from the oceans."
    ], // Dark Teal

    //40//
    "minecraft:elderguardian": [
        "§r- Giant guardian of the oceans."
    ], // Dark Blue

    //41//
    "minecraft:enderdragon": [
        "§r- Majestic dragon of the End."
    ], // Purple

    //42//
    "minecraft:endermite": [
        "§r- Small parasite of Endermen."
    ], // Purple

    //43//
    "minecraft:evoker": [
        "§r- Dark magic, summons Vex."
    ], // Gray

    //44//
    "minecraft:ghast": [
        "§r- Giant ghost that spits fire."
    ], // White

    //45//
    "minecraft:guardian": [
        "§r- Defender of ocean ruins."
    ], // Dark Blue

    //46//
    "minecraft:hoglin": [
        "§r- Aggressive creature from the Nether."
    ], // Gold

    //47//
    "minecraft:husk": [
        "§r- Desert zombie, resistant to sunlight."
    ], // Gray

    //48//
    "minecraft:magma_cube": [
        "§r- Bouncing cube from the Nether."
    ], // Dark Red

    //49//
    "minecraft:phantom": [
        "§r- Nocturnal flying apparition."
    ], // Dark Teal

    //50//
    "minecraft:piglin": [
        "§r- Nether inhabitant, loves gold."
    ], // Light Yellow

    //51//
    "minecraft:piglin_brute": [
        "§r- Stronger than a regular Piglin."
    ], // Gold

    //52//
    "minecraft:pillager": [
        "§r- Raider that attacks villages."
    ], // Gray

    //53//
    "minecraft:ravager": [
        "§r- Large and destructive in raids."
    ], // Dark Gray

    //54//
    "minecraft:shulker": [
        "§r- Hides in its shell."
    ], // Purple

    //55//
    "minecraft:silverfish": [
        "§r- Small and annoying in caves."
    ], // Gray

    //56//
    "minecraft:skeleton": [
        "§r- Relentless skeletal archer."
    ], // Gray

    //57//
    "minecraft:slime": [
        "§r- Green, bouncing cube."
    ], // Green

    //58//
    "minecraft:stray": [
        "§r- Chilly, resilient skeleton."
    ], // Dark Gray

    //59//
    "minecraft:vex": [
        "§r- Small, quick, and lethal."
    ], // Gray

    //60//
    "minecraft:vindicator": [
        "§r- Wields a deadly axe."
    ], // Gray

    //61//
    "minecraft:warden": [
        "§r- Blind but powerful guard."
    ], // Black

    //62//
    "minecraft:witch": [
        "§r- Uses potions against foes."
    ], // Purple

    //63//
    "minecraft:wither_boss": [
        "§r- Destructive boss, hard to beat."
    ], // Black

    //64//
    "minecraft:wither_skeleton": [
        "§r- Giant skeleton with a sword."
    ], // Dark Gray

    //65//
    "minecraft:zoglin": [
        "§r- Zombified, fierce Hoglin."
    ], // Gold

    //66//
    "minecraft:zombie": [
        "§r- Persistent classic enemy."
    ], // Green

    //67//
    "minecraft:zombie_villager": [
        "§r- Zombified, hostile villager."
    ], // Green

    //§r-§r-§r- Neutral Mobs: §r-§r-§r-

    //68//
    "minecraft:bee": [
        "§r- Pollinating, friendly bees."
    ], // Light Yellow

    //69//
    "minecraft:cave_spider": [
        "§r- Small, venomous in the dark."
    ], // Green

    //70//
    "minecraft:dolphin": [
        "§r- Friendly, helps find treasure."
    ], // Gray

    //71//
    "minecraft:enderman": [
        "§r- Teleports and steals blocks."
    ], // Purple

    //72//
    "minecraft:goat": [
        "§r- Loves jumping on mountains."
    ], // White

    //73//
    "minecraft:iron_golem": [
        "§r- Protector of villages."
    ], // Gray

    //74//
    "minecraft:llama": [
        "§r- Can carry items on travels."
    ], // Light Yellow

    //75//
    "minecraft:polar_bear": [
        "§r- Strong, lives in snow biomes."
    ], // White

    //76//
    "minecraft:pufferfish": [
        "§r- Inflates when threatened."
    ], // Light Yellow

    //77//
    "minecraft:spider": [
        "§r- Climbs walls, quick."
    ], // Green

    //78//
    "minecraft:trader_llama": [
        "§r- Carries items for the nomadic trader."
    ], // Light Yellow

    //79//
    "minecraft:wandering_trader": [
        "§r- Nomadic trader with rare items."
    ], // Light Blue

    //80//
    "minecraft:wolf": [
        "§r- Can be tamed as a pet."
    ], // Gray

    //81//
    "minecraft:zombie_pigman": [
        "§r- Zombie Pigman from the Nether."
    ] // Green
};

let savedEntities = {};

// Função para inverter as palavras, mantendo a formatação
function invertWords(name) {
    // Divide a string em palavras, inverte cada palavra e mantém a formatação
    return name.split(' ').map(word => {
        let formattedWord = '';
        let plainWord = '';

        // Extrai os caracteres da palavra, ignorando os códigos de formatação
        for (let i = 0; i < word.length; i++) {
            if (word[i] === '§' && i < word.length - 1) {
                formattedWord += word[i] + word[i + 1];
                i++; // Pula o próximo caractere de formatação
            } else {
                plainWord += word[i];
            }
        }

        // Inverte a palavra simples e adiciona os códigos de formatação de volta
        let invertedWord = plainWord.split('').reverse().join('');
        let result = '';
        let plainIndex = 0;

        for (let i = 0; i < word.length; i++) {
            if (word[i] === '§' && i < word.length - 1) {
                result += word[i] + word[i + 1];
                i++; // Pula o próximo caractere de formatação
            } else {
                result += invertedWord[plainIndex++];
            }
        }

        return result;
    }).join(' ');
}

// Captura e salva entidades que não são negadas
world.afterEvents.entityHitEntity.subscribe((data) => {
    const { damagingEntity, hitEntity } = data;
    if (damagingEntity.typeId !== "minecraft:player") return;

    const equipment = damagingEntity.getComponent("equippable").getEquipment("Mainhand");
    if (!equipment || equipment.typeId !== "sk:prision_portable_advanced") return;

    const family = hitEntity.getComponent("type_family");
    if (!family || hitEntity.typeId === "minecraft:painting" || EntitiesDeny.includes(hitEntity.typeId) || family.hasTypeFamily("npc") || family.hasTypeFamily("inanimate")) {
        // Exibe mensagem e toca som de noteblock apenas se segurando a prisão portátil intermediária
        damagingEntity.runCommand(`title ${damagingEntity.name} actionbar §cYou cannot capture this entity!`);
        damagingEntity.runCommand(`playsound note.bass ${damagingEntity.name}`);
        return;
    }

    const { x, y, z } = hitEntity.location;

    let entityName = EntityNames[hitEntity.typeId] || hitEntity.typeId;  // Usa o nome personalizado ou o ID da entidade
    let entityLore = EntityLores[hitEntity.typeId] || [];  // Usa a lore personalizada ou uma lista vazia

    // Verifica se é uma ovelha nomeada como "jeb_"
    if (hitEntity.typeId === "minecraft:sheep" && hitEntity.nameTag.toLowerCase() === "jeb_") {
        // Name colorido e em negrito para "Rainbow Sheep"
        entityName = "§l§cR§6a§ei§2n§9b§5o§dw §cS§6h§ee§9p";  // Name em cores de arco-íris com negrito no início
        entityLore = ["- §rA magical sheep that changes color.", "- §rKnown as the legendary Jeb_."];
    }

    // Verifica se o mob está nomeado como "Grumm" e inverte as palavras, mantendo a formatação
    if (hitEntity.nameTag === "Grumm") {
        entityName = invertWords(entityName);
    }

    const lore = ["", `§r§lName:§r ${entityName}`, ...entityLore];  // Adiciona a lore à lista de lore do item
    equipment.setLore(lore);  // Define a lore no item
    damagingEntity.getComponent("equippable").setEquipment("Mainhand", equipment);
    hitEntity.runCommand(`tp ${x} ${y + 320} ${z}`);
    const entityKey = `${hitEntity.id}_${x}_${y}_${z}`; // Use o ID da entidade para a chave
    savedEntities[entityKey] = { x, y: y + 320, z, name: entityName }; // Salve o nome da entidade também
    const capturedMessage = `§rThe entity ${entityName}§r has been collected in its portable prison`;  // Mensagem com texto colorido apenas no nome da entidade
    hitEntity.runCommand(`title ${damagingEntity.name} actionbar §a${capturedMessage}`);
    hitEntity.runCommand(`structure save "${entityKey}" ${x} ${y + 320} ${z} ${x} ${y + 320} ${z} true disk false`);

    damagingEntity.runCommand(`playsound prision_portable_use`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
    damagingEntity.runCommand(`particle minecraft:endrod ${x} ${y + 2} ${z}`);
    damagingEntity.runCommand(`particle minecraft:endrod ${x} ${y + 1.9} ${z}`);
    damagingEntity.runCommand(`particle minecraft:endrod ${x} ${y + 1.8} ${z}`);

    hitEntity.remove();
});

// Manipula o uso do item para reposicionar a entidade capturada
world.beforeEvents.worldInitialize.subscribe((data) => {
    data.itemComponentRegistry.registerCustomComponent("sk:prision_advanced", {
        onUseOn: (event) => {
            const { block, blockFace, source, itemStack } = event;
            const pos = block.location;
            const direction = {
                "North": { x: pos.x + 0.5, y: pos.y, z: pos.z - 0.5 },
                "South": { x: pos.x + 0.5, y: pos.y, z: pos.z + 1.5 },
                "East": { x: pos.x + 1.5, y: pos.y, z: pos.z + 0.5 },
                "West": { x: pos.x - 0.5, y: pos.y, z: pos.z + 0.5 },
                "Up": { x: pos.x + 0.5, y: pos.y + 1, z: pos.z + 0.5 },
                "Down": { x: pos.x + 0.5, y: pos.y - 1, z: pos.z + 0.5 }
            };
            const { x, y, z } = direction[blockFace];

            if (itemStack.getLore().length > 1) {
                const entityName = itemStack.getLore()[1].replace("§r§lName:§r ", "");  // Ajustado para pegar a segunda linha da lore
                const entityKey = Object.keys(savedEntities).find(key => savedEntities[key].name === entityName); // Encontre a chave pelo nome

                if (entityKey && savedEntities[entityKey]) {
                    source.runCommand(`structure load "${entityKey}" ${x} ${y} ${z}`);
                    source.runCommand(`structure delete "${entityKey}"`);

                    source.runCommand(`playsound prision_portable_use`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:totem_particle ${x} ${y + 1} ${z}`);
                    source.runCommand(`particle minecraft:endrod ${x} ${y + 2} ${z}`);
                    source.runCommand(`particle minecraft:endrod ${x} ${y + 1.9} ${z}`);
                    source.runCommand(`particle minecraft:endrod ${x} ${y + 1.8} ${z}`);

                    delete savedEntities[entityKey];
                }
                itemStack.setLore([]);
                source.getComponent("equippable").setEquipment("Mainhand", itemStack);
            }
        }
    });
});

const prision_advanced = "sk:prision_portable_advanced";

function checkPlayerInventory() {
  for (const player of world.getPlayers()) {
    const inventory = player.getComponent('minecraft:inventory').container;
    for (let i = 0; i < inventory.size; i++) {
      const item = inventory.getItem(i);
      if (item && item.typeId === prision_advanced && item.getLore().length === 0) {
        item.setLore(['', '§rUse this item to capture:', ' §r- §l§3Peaceful entities', ' §r- §l§4Aggressive entities (including boses)']);

        inventory.setItem(i, item);
      }      
    }    
  }
  system.runTimeout(checkPlayerInventory, 1);
}

checkPlayerInventory();
